<template>
  <div class="page">
    <div
      v-if="routeFrom && routeFrom.name === 'SphereDetail'"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Groupe d'organisations
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Organisations' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Organisations
      </span>
    </div>
    <b-overlay
      v-if="loading"
      id="overlay-background"
      :show="loading"
      :variant="'white'"
      :opacity="0.7"
      :blur="'2px'"
      rounded="sm"
      style="min-height: 30em;"
    />
    <b-container
      v-else
      fluid
    >
      <b-row>
        <b-col
          cols="8"
          class="detail-forms"
        >
          <h1>{{ currentOrganisation.display_name }}</h1>
          <OrganisationForm
            :organisation="currentOrganisation"
            @save="saveOrganisation"
          />
        </b-col>
        <b-col
          cols="4"
          class="detail-card"
        >
          <OrganisationCard
            :organisation="currentOrganisation"
            :usergroup="currentUsergroup"
          />
        </b-col>
      </b-row>
      <b-row style="height: auto;">
        <b-col
          cols="11"
          class="users-table"
        >
          <h3 class="line-header">
            <img
              src="@/assets/icons/face_user.svg"
              alt="Icône silhouette utilisateur"
            > Utilisateurs
          </h3>
          <p style="margin: 0 0 1em 1.2em; font-size: 1em;">
            Ajouter de nouveaux utilisateurs dans 
            <router-link
              to="/accounts/users"
            >
              Utilisateurs
            </router-link>
          </p>
          <b-overlay
            :show="loadingTable"
            :variant="'white'"
            :opacity="0.9"
            :blur="'2px'"
            rounded="sm"
          >
            <CustomTable
              :fields="membersFields"
              :items="membersItems"
              :route-to="'UserDetail'"
              :default-sorting="{
                sortedUp: true,
                sortedDown: false,
                sortedField: 'user__last_name'
              }"
              :sort-function="GET_USERGROUP_MEMBERS"
              @sorted="setMembersTableSorted"
              @delete="removeUserFromOrganisation"
              @loading="setTableLoader"
            />
            <Pagination
              :nbPages="Math.ceil(currentUsergroupMembersCount/50)"
              @change-page="changeTablePage"
            />
          </b-overlay>
        </b-col>
      </b-row>
      <b-row>
        <b-col
          cols="11"
        >
          <h3 class="line-header">
            <img
              src="@/assets/icons/sphere_planet.svg"
              alt="Icône sphère"
            > Groupes d'organisations
          </h3>
          <div style="margin-left: 1em;">
            <label>
              Ajouter cette organisation à des groupe d'organisations
            </label>
            <p>
              L'ajout de cette organisation à un groupe d'organisation donnera accès aux données 
              et collections de données associées à ce groupe d'organisation.
            </p>
            <SearchUsergroups
              style="width: 60%;"
              :types="['group-of-organisation']"
              :limit="100"
              @select="addOrgToSphere"
            />
            <div
              v-if="selectedSpheres.length > 0"
              id="orga-spheres-container"
            >
              <div
                v-for="selectedSphere of selectedSpheres"
                :key="selectedSphere.id"
                class="orga-sphere"
              >
                {{ selectedSphere.display_name }}
                <b-icon-x
                  font-scale="1.5"
                  @click="removeOrgFromSphere"
                />
              </div>
            </div>
          </div>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import OrganisationForm from '@/components/Forms/OrganisationForm.vue';
import OrganisationCard from '@/components/Cards/OrganisationCard.vue';
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import SearchUsergroups from '@/components/SearchUsergroups.vue';

import { mapState, mapActions } from 'vuex';

import usergroupsAPI from '@/api/usergroupsAPI.js';

export default {
  name: 'OrganisationDetail',

  components: {
    OrganisationForm,
    OrganisationCard,
    CustomTable,
    Pagination,
    SearchUsergroups
  },

  data() {
    return {
      routeFrom: null,
      loading: false,
      loadingTable: false,
      sphere: null,
      selectedSpheres: [],
      membersFields: [
        {
          key: 'Nom',
          apiName: 'user__last_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Prénom',
          apiName: 'user__first_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Identifiant',
          apiName: 'user__username',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Rôle',
          apiName: 'role',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Date d\'inscription',
          apiName: 'date_joined',
          sortable: true,
          width: '15%',
          centered: true
        },
        {
          key: 'Dernière connexion',
          apiName: 'user__last_login',
          sortable: true,
          width: '15%',
          centered: true
        },
        {
          key: 'Statut',
          apiName: 'status',
          sortable: true,
          width: '8%',
          centered: true
        },
        {
          key: 'Admin',
          apiName: 'is_superuser',
          sortable: false,
          width: '6%',
          centered: true
        },
        {
          key: 'Retirer de l\'organisation',
          sortable: false,
          width: '15%',
          centered: true
        }
      ],
      membersTableSorted: {
        direction: '',
        field: 'user__last_name'
      }
    };
  },

  computed: {
    ...mapState('users', ['usersList']),
    ...mapState('organisations', [
      'currentOrganisation',
      'usergroupsRoles',
      'organisationError'
    ]),
    ...mapState('usergroups', [
      'currentUsergroup',
      'usergroupsRoles',
      'currentUsergroupMembers',
      'currentUsergroupMembersCount',
      'spheres'
    ]),
    membersItems() {
      return this.currentUsergroupMembers.map(el => {
        return {
          id: el.user.id,
          Nom:
            el.user.last_name,
          Prénom:
            el.user.first_name,
          Identifiant:
            el.user.username,
          Rôle:
            this.usergroupsRoles.find(item => item.choice === el.role) ? this.usergroupsRoles.find(item => item.choice === el.role).label : '',
          'Date d\'inscription':
            el.date_joined ? new Date(el.date_joined).toLocaleString('fr-FR', { year: 'numeric', month: 'long', day: 'numeric' }) : '',
          'Dernière connexion':
             el.user.last_login ? new Date(el.user.last_login).toLocaleString('fr-FR', { year: 'numeric', month: 'long', day: 'numeric' }) : '',
          Statut: [
            { choice: 0, value: 'secondary' },
            { choice: 1, value: 'warning' },
            { choice: 2, value: 'success' }
          ].find(item => item.choice === el.status).value,
          Admin: el.user.is_superuser ? el.user.is_superuser : false
        };
      });
    }
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
      vm.routeFrom = from;
    });
  },

  created() {
    this.loading = true;
    this.GET_ORGANISATION_DETAIL(this.$route.params.id).then(() => {
      Promise.all([
        this.GET_USERGROUP_MEMBERS({
          id: this.currentOrganisation.usergroup.id,
          ...this.membersTableSorted
        }),
        this.GET_USERGROUP_DETAIL(this.currentOrganisation.usergroup.id),
        this.GET_ORGANISATIONS_TYPES(),
        this.GET_ORGANISATIONS_JURIDICTIONS()
      ])
        .then(() => {
          for (const id of this.currentUsergroup.parents) {
            usergroupsAPI.getUsergroup(id)
              .then((resp) => {
                this.selectedSpheres.push(resp);
              });
          }
          this.loading = false;
        });
    });
    if (this.usergroupsRoles.length === 0) {
      this.GET_USERGROUPS_ROLES();
    }
    if (this.usersList.length === 0) {
      this.GET_USERS_LIST({
        direction: null,
        field: null
      });
    }
    // TODO: replace with search
    if (this.spheres.length === 0) {
      this.GET_USERGROUPS_SPHERES_LIST({
        direction: null,
        field: null,
        page: 1
      });
    }
  },

  methods: {
    ...mapActions('organisations', [
      'GET_ORGANISATION_DETAIL',
      'GET_ORGANISATIONS_LIST',
      'UPDATE_ORGANISATION',
      'SET_ORGANISATION_THUMBNAIL',
      'SET_ORGANISATION_AGREEMENT',
      'GET_ORGANISATIONS_TYPES',
      'GET_ORGANISATIONS_JURIDICTIONS'
    ]),
    ...mapActions('users', ['GET_USERS_LIST']),
    ...mapActions('usergroups', [
      'GET_USERGROUP_DETAIL',
      'GET_USERGROUPS_ROLES',
      'GET_USERGROUP_MEMBERS',
      'UPDATE_USERGROUP',
      'GET_USERGROUPS_SPHERES_LIST'
    ]),

    removeUserFromOrganisation(e) {
      const index = this.currentUsergroupMembers.findIndex(el => el.user.id === e.id);
      this.currentUsergroupMembers.splice(index, 1);

      const data = {
        codename: this.currentOrganisation.codename,
        display_name: this.currentOrganisation.display_name,
        organisation_type: this.currentOrganisation.organisation_type,
        usergroup: this.currentOrganisation.usergroup
      };
      this.loading = true;
      this.UPDATE_ORGANISATION({
        id: this.currentOrganisation.id,
        data: data
      })
        .then(() => {
          Promise.all([
            this.GET_ORGANISATION_DETAIL(this.$route.params.id),
            this.GET_USERGROUP_MEMBERS({ id: this.currentOrganisation.usergroup.id }),
            this.GET_ORGANISATIONS_LIST({
              direction: null,
              field: null
            }),
            this.GET_USERS_LIST({
              direction: null,
              field: null
            })
          ]).then(() => {
            this.loading = false;
          });
        })
        .catch(() => {
          this.loading = false;
        });
    },

    saveOrganisation(data) {
      this.loading = true;
      this.UPDATE_ORGANISATION({
        id: this.currentOrganisation.id,
        data: data.form
      })
        .then(() => {
          Promise.all([
            data.thumbnail ?
              this.SET_ORGANISATION_THUMBNAIL({
                id: this.currentOrganisation.id,
                data: data.thumbnail
              }) : Promise.resolve(),
            data.agreement ?
              this.SET_ORGANISATION_AGREEMENT({
                id: this.currentOrganisation.id,
                data: data.agreement
              }) : Promise.resolve()
          ]).then(() => {
            Promise.all([
              this.GET_ORGANISATION_DETAIL(this.$route.params.id),
              this.GET_ORGANISATIONS_LIST({
                direction: null,
                field: null
              }),
              this.GET_USERS_LIST({
                direction: null,
                field: null
              })
            ]).then(() => {
              this.loading = false;
            });
          });
        })
        .catch(() => {
          this.loading = false;
        });
    },

    changeTablePage() {
      this.setTableLoader(true);
      this.GET_USERGROUP_MEMBERS({
        id: this.currentOrganisation.usergroup.id,
        ...this.membersTableSorted
      })
        .then(() => {
          this.setTableLoader(false);
        })
        .catch((err) => {
          console.error(err);
          this.setTableLoader(false);
        });
    },

    setTableLoader(e) {
      this.loadingTable = e;
    },

    setMembersTableSorted(e) {
      this.membersTableSorted = e;
    },

    addOrgToSphere(e) {
      const index = this.selectedSpheres.findIndex(el => el.id === e.id);
      if (index === -1) {
        this.selectedSpheres.push(e);
        this.UPDATE_USERGROUP({
          id: this.currentUsergroup.id,
          data: {
            ...this.currentUsergroup,
            parents: this.selectedSpheres.map((el) => { return el.id; })
          }
        });
      }
      this.sphere = null;
    },

    removeOrgFromSphere(e) {
      const index = this.selectedSpheres.findIndex(el => el.id === e.id);
      this.selectedSpheres.splice(index, 1);
      this.UPDATE_USERGROUP({
        id: this.currentUsergroup.id,
        data: {
          ...this.currentUsergroup,
          parents: this.selectedSpheres.map((el) => { return el.id; })
        }
      });
    }
  }
};
</script>

<style lang="less" scoped>

.container-fluid {
  margin: 1em;
  padding-bottom: 3em;
  height: fit-content;
  .row {
    height: fit-content;
  }
}

p {
  width: 100%;
  color: grey;
  font-style: italic;
  font-size: 0.7em;
  margin-bottom: 0.2em;
}

#orga-spheres-container {
  display: flex;
  flex-flow: row wrap;
  padding: 0.1em;
  margin: 0.5em 0;
  .orga-sphere {
    display: flex;
    margin: 0.2em 1em 0.2em 0;
    padding: 0.5em;
    border-radius: 10px;
    font-size: 0.9em;
    background-color: @blue;
    color: white;
    .b-icon {
      cursor: pointer;
    }
  }
}

</style>
